Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44197)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.expressionevaluator/org.gvsig.expressionevaluator.lib/org.gvsig.expressionevaluator.lib.impl/src/main/java/org/gvsig/expressionevaluator/impl/DefaultExpressionBuilder.java	(revision 44198)
@@ -995,438 +1081,474 @@
         if (this.value == null) {
             return this.set(value);
         }
-        BinaryOperator operator = binaryOperator("OR", config.getString(Config.operator_OR), this.value, value);
+        BinaryOperator operator = binaryOperator(OPERATOR_OR, FORMAT_OPERATOR_OR, this.value, value);
         this.value = operator;
         return this;
     }
 
     @Override
     public Function ST_Intersects(Value geom1, Value geom2) {
-        return builtin_function("ST_Intersects", config.getString(Config.ST_Intersects), geom1, geom2);
+        return builtin_function(FUNCTION_ST_INTERSECTS, FORMAT_ST_INTERSECTS, geom1, geom2);
     }
 
     @Override
     public Function ST_SRID(Value geom) {
-        return builtin_function("ST_SRID", config.getString(Config.ST_SRID), geom);
+        return builtin_function(FUNCTION_ST_SRID, FORMAT_ST_SRID, geom);
     }
 
     @Override
     public Function ST_Envelope(Value geom) {
-        return builtin_function("ST_Envelope", config.getString(Config.ST_Envelope), geom);
+        return builtin_function(FUNCTION_ST_ENVELOPE, FORMAT_ST_ENVELOPE, geom);
     }
 
     @Override
     public Function ST_AsText(Value geom) {
-        return builtin_function("ST_AsText", config.getString(Config.ST_AsText), geom);
+        return builtin_function(FUNCTION_ST_ASTEXT, FORMAT_ST_ASTEXT, geom);
     }
 
     @Override
     public Function ST_AsBinary(Value geom) {
-        return builtin_function("ST_AsBinary", config.getString(Config.ST_AsBinary), geom);
+        return builtin_function(FUNCTION_ST_ASBINARY, FORMAT_ST_ASBINARY, geom);
     }
 
     @Override
     public Function ST_AsEWKB(Value geom) {
-        return builtin_function("ST_AsEWKB", config.getString(Config.ST_AsEWKB), geom);
+        return builtin_function(FUNCTION_ST_ASEWKB, FORMAT_ST_ASEWKB, geom);
     }
 
     @Override
     public Function ST_GeomFromText(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromText", config.getString(Config.ST_GeomFromText), geom, crs);
+        return builtin_function(FUNCTION_ST_GEOMFROMTEXT, FORMAT_ST_GEOMFROMTEXT, geom, crs);
     }
 
     @Override
     public Function ST_GeomFromWKB(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromWKB", config.getString(Config.ST_GeomFromWKB), geom, crs);
+        return builtin_function(FUNCTION_ST_GEOMFROMWKB, FORMAT_ST_GEOMFROMWKB, geom, crs);
     }
 
     @Override
     public Function ST_GeomFromEWKB(Value geom, Value crs) {
-        return builtin_function("ST_GeomFromEWKB", config.getString(Config.ST_GeomFromEWKB), geom, crs);
+        return builtin_function(FUNCTION_ST_GEOMFROMEWKB, FORMAT_ST_GEOMFROMEWKB, geom, crs);
     }
 
     @Override
     public Function ST_Simplify(Value geom, Value tolerance) {
-        return builtin_function("ST_Simplify", config.getString(Config.ST_Simplify), tolerance);
+        return builtin_function(FUNCTION_ST_SIMPLIFY, FORMAT_ST_SIMPLIFY, tolerance);
     }
 
     @Override
     public Function ST_Disjoint(Value geom1, Value geom2) {
-        return builtin_function("ST_Disjoint", config.getString(Config.ST_Disjoint), geom1, geom2);
+        return builtin_function(FUNCTION_ST_DISJOINT, FORMAT_ST_DISJOINT, geom1, geom2);
     }
 
     @Override
     public Function ST_Contains(Value geom1, Value geom2) {
-        return builtin_function("ST_Contains", config.getString(Config.ST_Contains), geom1, geom2);
+        return builtin_function(FUNCTION_ST_CONTAINS, FORMAT_ST_CONTAINS, geom1, geom2);
     }
 
     @Override
     public Function ST_Equals(Value geom1, Value geom2) {
-        return builtin_function("ST_Equals", config.getString(Config.ST_Equals), geom1, geom2);
+        return builtin_function(FUNCTION_ST_EQUALS, FORMAT_ST_EQUALS, geom1, geom2);
     }
 
     @Override
     public Function ST_Crosses(Value geom1, Value geom2) {
-        return builtin_function("ST_Crosses", config.getString(Config.ST_Crosses), geom1, geom2);
+        return builtin_function(FUNCTION_ST_CROSSES, FORMAT_ST_CROSSES, geom1, geom2);
     }
 
     @Override
     public Function ST_IsClosed(Value geom) {
-        return builtin_function("ST_IsClosed", config.getString(Config.ST_IsClosed), geom);
+        return builtin_function(FUNCTION_ST_ISCLOSED, FORMAT_ST_ISCLOSED, geom);
     }
 
     @Override
     public Function ST_Overlaps(Value geom1, Value geom2) {
-        return builtin_function("ST_Overlaps", config.getString(Config.ST_Overlaps), geom1, geom2);
+        return builtin_function(FUNCTION_ST_OVERLAPS, FORMAT_ST_OVERLAPS, geom1, geom2);
     }
 
     @Override
     public Function ST_Touches(Value geom1, Value geom2) {
-        return builtin_function("ST_Touches", config.getString(Config.ST_Touches), geom1, geom2);
+        return builtin_function(FUNCTION_ST_TOUCHES, FORMAT_ST_TOUCHES, geom1, geom2);
     }
 
     @Override
     public Function ST_Within(Value geom1, Value geom2) {
-        return builtin_function("ST_Within", config.getString(Config.ST_Within), geom1, geom2);
+        return builtin_function("ST_Within", FORMAT_ST_WITHIN, geom1, geom2);
     }
 
     @Override
-    public Function isNull(Value value) {
-        return builtin_function("IS NULL", config.getString(Config.isNull), value);
+    public Function is_null(Value value) {
+        return builtin_function("IS NULL", FORMAT_ISNULL, value);
     }
 
     @Override
-    public Function notIsNull(Value value) {
-        return builtin_function("NOT IS NULL", config.getString(Config.notIsNull), value);
+    public Function not_is_null(Value value) {
+        return builtin_function("NOT IS NULL", FORMAT_NOTISNULL, value);
     }
 
     @Override
     public Function not(Value value) {
-        return builtin_function("NOT", config.getString(Config.operator_not), value);
+        return builtin_function(OPERATOR_NOT, FORMAT_OPERATOR_NOT, value);
     }
 
     @Override
-    public Function lcase(Value s) {
-        return builtin_function("LCASE", config.getString(Config.lcase), s);
-    }
-
-    @Override
-    public Function ucase(Value s) {
-        return builtin_function("UCASE", config.getString(Config.ucase), s);
-    }
-
-    @Override
     public BinaryOperator and(Value leftOperand, Value rightOperand) {
-        return binaryOperator("AND", config.getString(Config.operator_AND), leftOperand, rightOperand);
+        return binaryOperator(OPERATOR_AND, FORMAT_OPERATOR_AND, leftOperand, rightOperand);
     }
 
     @Override
     public BinaryOperator or(Value leftOperand, Value rightOperand) {
-        return binaryOperator("OR", config.getString(Config.operator_OR), leftOperand, rightOperand);
+        return binaryOperator(OPERATOR_OR, FORMAT_OPERATOR_OR, leftOperand, rightOperand);
     }
 
     @Override
     public BinaryOperator eq(Value leftOperand, Value rightOperand) {
-        return binaryOperator("=", config.getString(Config.operator_EQ), leftOperand, rightOperand);
+        return binaryOperator("=", FORMAT_OPERATOR_EQ, leftOperand, rightOperand);
     }
 
     @Override
     public BinaryOperator ne(Value leftOperand, Value rightOperand) {
-        return binaryOperator("<>", config.getString(Config.operator_NE), leftOperand, rightOperand);
+        return binaryOperator("<>", FORMAT_OPERATOR_NE, leftOperand, rightOperand);
     }
 
     @Override
     public BinaryOperator gt(Value op1, Value op2) {
-        return binaryOperator(">", config.getString(Config.operator_GT), op1, op2);
+        return binaryOperator(">", FORMAT_OPERATOR_GT, op1, op2);
     }
 
     @Override
     public BinaryOperator ge(Value op1, Value op2) {
-        return binaryOperator(">=", config.getString(Config.operator_GE), op1, op2);
+        return binaryOperator(">=", FORMAT_OPERATOR_GE, op1, op2);
     }
 
     @Override
     public BinaryOperator lt(Value op1, Value op2) {
-        return binaryOperator("<", config.getString(Config.operator_LT), op1, op2);
+        return binaryOperator("<", FORMAT_OPERATOR_LT, op1, op2);
     }
 
     @Override
     public BinaryOperator le(Value op1, Value op2) {
-        return binaryOperator("<=", config.getString(Config.operator_LE), op1, op2);
+        return binaryOperator("<=", FORMAT_OPERATOR_LE, op1, op2);
     }
 
     @Override
     public BinaryOperator like(Value op1, Value op2) {
-        return binaryOperator("LIKE", config.getString(Config.operator_LIKE), op1, op2);
+        return binaryOperator(OPERATOR_LIKE, FORMAT_OPERATOR_LIKE, op1, op2);
     }
 
     @Override
     public BinaryOperator ilike(Value op1, Value op2) {
-        return binaryOperator("ILIKE", config.getString(Config.operator_ILIKE), op1, op2);
+        return binaryOperator(OPERATOR_ILIKE, FORMAT_OPERATOR_ILIKE, op1, op2);
     }
 
     @Override
     public BinaryOperator add(Value op1, Value op2) {
-        return binaryOperator("ADD", config.getString(Config.operator_add), op1, op2);
+        return binaryOperator(OPERATOR_ADD, FORMAT_OPERATOR_ADD, op1, op2);
     }
 
     @Override
     public BinaryOperator subst(Value op1, Value op2) {
-        return binaryOperator("SUBST", config.getString(Config.operator_subst), op1, op2);
+        return binaryOperator(OPERATOR_SUBST, FORMAT_OPERATOR_SUBST, op1, op2);
     }
 
     @Override
     public BinaryOperator mult(Value op1, Value op2) {
-        return binaryOperator("MULT", config.getString(Config.operator_mult), op1, op2);
+        return binaryOperator(OPERATOR_MULT, FORMAT_OPERATOR_MULT, op1, op2);
     }
 
     @Override
     public BinaryOperator div(Value op1, Value op2) {
-        return binaryOperator("DIV", config.getString(Config.operator_div), op1, op2);
+        return binaryOperator(OPERATOR_DIV, FORMAT_OPERATOR_DIV, op1, op2);
     }
 
     @Override
     public BinaryOperator concat(Value op1, Value op2) {
-        return binaryOperator("CONCAT", config.getString(Config.operator_concat), op1, op2);
+        return binaryOperator(OPERATOR_CONCAT, FORMAT_OPERATOR_CONCAT, op1, op2);
     }
     
     @Override
     public Function iif(Value condition, Value iftrue, Value iffalse) {
-        return builtin_function("IIF", config.getString(Config.iif), condition, iftrue, iffalse);
+        return function(FUNCTION_IIF, condition, iftrue, iffalse);
     }
 
     @Override
     public Function ifnull(Value value, Value iftrue, Value iffalse) {
-        return builtin_function("IFNULL", config.getString(Config.ifnull), value, iftrue, iffalse);
+        return function(FUNCTION_IFNULL, value, iftrue, iffalse);
     }
     
     @Override
     public Function left(Value str, Value size) {
-       return function("left", str, size);
-       // return builtin_function("left", "left({1})",str,size);
+       return function(FUNCTION_LEFT, str, size);
     }
     
     @Override
     public Function right(Value str, Value len) {
-       return function("right", str, len);
+       return function(FUNCTION_RIGHT, str, len);
     }
     
     @Override
     public Function locate(Value search, Value str, Value start) {
-       return function("locate", search, str, start);
+       return function(FUNCTION_LOCATE, search, str, start);
     }
     
     @Override
     public Function position(Value search, Value str) {
-       return function("position", search, str);
+       return function(FUNCTION_POSITION, search, str);
     }
     
     @Override
     public Function lpad(Value str, Value len, Value padstr) {
-       return function("lpad", str, len, padstr);
+       return function(FUNCTION_LPAD, str, len, padstr);
     }
     
     @Override
     public Function rpad(Value str, Value len, Value padstr) {
-       return function("rpad", str, len, padstr);
+       return function(FUNCTION_RPAD, str, len, padstr);
     }
     
     @Override
     public Function ltrim(Value str) {
-       return function("ltrim", str);
+       return function(FUNCTION_LTRIM, str);
     }
     
     @Override
     public Function rtrim(Value str) {
-       return function("rtrim", str);
+       return function(FUNCTION_RTRIM, str);
     }
     
     @Override
     public Function trim(Value str) {
-       return function("trim", str);
+       return function(FUNCTION_TRIM, str);
     }
     
     @Override
     public Function repeat(Value str, Value size) {
-       return function("repeat", str, size);
+       return function(FUNCTION_REPEAT, str, size);
     }
     
     @Override
     public Function replace(Value str, Value search, Value replstr) {
-       return function("replace", str, search, replstr);
+       return function(FUNCTION_REPLACE, str, search, replstr);
     }
     
     @Override
     public Function ascii(Value str) {
-       return function("ascii", str);
+       return function(FUNCTION_ASCII, str);
     }
     
     @Override
     public Function lenght(Value str) {
-       return function("lenght", str);
+       return function(FUNCTION_LENGHT, str);
     }
 
     @Override
     public Function instr(Value str, Value search, Value start) {
-       return function("instr", str, search, start);
+       return function(FUNCTION_INSTR, str, search, start);
     }
     
     @Override
     public Function lower(Value str) {
-       return function("lower", str);
+       return function(FUNCTION_LOWER, str);
     }
     
     @Override
     public Function upper(Value str) {
-       return function("upper", str);
+       return function(FUNCTION_UPPER, str);
     }
     
     @Override
     public Function space(Value size) {
-       return function("space", size);
+       return function(FUNCTION_SPACE, size);
     }
     
     @Override
     public Function substring(Value str, Value start, Value len) {
-       return function("substring", str, start, len);
+       return function(FUNCTION_SUBSTRING, str, start, len);
     }
     
     @Override
     public Function acos(Value num) {
-       return function("acos", num);
+       return function(FUNCTION_ACOS, num);
     } 
     
     @Override
     public Function asin(Value num) {
-       return function("asin", num);
+       return function(FUNCTION_ASIN, num);
     }
     
     @Override
     public Function atan(Value num) {
-       return function("atan", num);
+       return function(FUNCTION_ATAN, num);
     }
     
     @Override
     public Function cos(Value num) {
-       return function("cos", num);
+       return function(FUNCTION_COS, num);
     }
     
     @Override
     public Function cosh(Value num) {
-       return function("cosh", num);
+       return function(FUNCTION_COSH, num);
     }
     
     @Override
     public Function cot(Value num) {
-       return function("cot", num);
+       return function(FUNCTION_COT, num);
     }  
     
     @Override
     public Function bitand(Value num1, Value num2) {
-       return function("bitand", num1, num2);
+       return function(FUNCTION_BITAND, num1, num2);
     } 
     
     @Override
     public Function bitor(Value num1, Value num2) {
-       return function("bitor", num1, num2);
+       return function(FUNCTION_BITOR, num1, num2);
     }
     
     @Override
     public Function bitxor(Value num1, Value num2) {
-       return function("bitxor", num1, num2);
+       return function(FUNCTION_BITXOR, num1, num2);
     }
     
     @Override
     public Function ceil(Value num) {
-       return function("ceil", num);
+       return function(FUNCTION_CEIL, num);
     }
     
     @Override
     public Function degrees(Value num) {
-       return function("degrees", num);
+       return function(FUNCTION_DEGREES, num);
     }  
     
     @Override
     public Function exp(Value num) {
-       return function("exp", num);
+       return function(FUNCTION_EXP, num);
     }  
     
     @Override
     public Function floor(Value num) {
-       return function("floor", num);
+       return function(FUNCTION_FLOOR, num);
     }  
     
     @Override
     public Function log(Value num) {
-       return function("log", num);
+       return function(FUNCTION_LOG, num);
     }  
     
     @Override
     public Function log10(Value num) {
-       return function("log10", num);
+       return function(FUNCTION_LOG10, num);
     }  
     
     @Override
     public Function pi(Value num) {
-       return function("pi", num);
+       return function(FUNCTION_PI, num);
     }
     
     @Override
     public Function power(Value num) {
-       return function("power", num);
+       return function(FUNCTION_POWER, num);
     }
     
     @Override
     public Function radians(Value num) {
-       return function("radians", num);
+       return function(FUNCTION_RADIANS, num);
     }
     
     @Override
     public Function rand(Value num) {
-       return function("rand", num);
+       return function(FUNCTION_RAND, num);
     }
     
     @Override
     public Function round(Value num) {
-       return function("round", num);
+       return function(FUNCTION_ROUND, num);
     }
     
     @Override
     public Function sqrt(Value num) {
-       return function("sqrt", num);
+       return function(FUNCTION_SQRT, num);
     }
     
     @Override
     public Function sign(Value num) {
-       return function("sign", num);
+       return function(FUNCTION_SIGN, num);
     }
     
     @Override
     public Function sin(Value num) {
-       return function("sin", num);
+       return function(FUNCTION_SIN, num);
     }
     
     @Override
     public Function sinh(Value num) {
-       return function("sinh", num);
+       return function(FUNCTION_SINH, num);
     }
     
     @Override
     public Function tan(Value num) {
-       return function("tan", num);
+       return function(FUNCTION_TAN, num);
     }
     @Override
     public Function tanh(Value num) {
-       return function("cosh", num);
+       return function(FUNCTION_TANH, num);
     }  
     
     @Override
     public Function zero() {
-       return function("zero");
+       return function(FUNCTION_ZERO);
     }
     
     @Override
     public Function chr(Value num) {
-       return function("chr", num);
+       return function(FUNCTION_CHR, num);
+    }    
+
+    @Override
+    public Function ST_ExtentAggregate(Value geom) {
+       return function(FUNCTION_ST_EXTENTAGGREGATE, geom);
     }
+
+    @Override
+    public Function ST_UnionAggregate(Value geom) {
+       return function(FUNCTION_ST_UNIONAGGREGATE, geom);
+    }
+
+    @Override
+    public Function cast(Value object, Value typeName) {
+       return function(FUNCTION_CAST, object, typeName);
+    }    
+
+    @Override
+    public Function decode(Value value, Value format) {
+       return function(FUNCTION_DECODE, value, format);
+    }    
+
+    @Override
+    public Function toDouble(Value num) {
+       return function(FUNCTION_TODOUBLE, num);
+    }    
+
+    @Override
+    public Function toFloat(Value num) {
+       return function(FUNCTION_TOFLOAT, num);
+    }    
+
+    @Override
+    public Function toLong(Value num) {
+       return function(FUNCTION_TOLONG, num);
+    }    
+
+    @Override
+    public Function toInteger(Value num) {
+       return function(FUNCTION_TOINTEGER, num);
+    }    
+
+    @Override
+    public Function toStr(Value object) {
+       return function(FUNCTION_TOSTR, object);
+    }    
+
+
 }
